# Purpose of this component

The purpose of oc-deploy, is to deploy all the OC components over a Kubernetes cluster.

An OpenCloud deployment is composed of the following layers: 

OpenCloud components | <-- TODO
--------------------------
KubernetesCluster | <-- TODO
-------------------------- 
IaaS (VMs, LAN) | <-- pre-requisite
--------------------------
HW (network and servers) | <-- pre-requisite
--------------------------


It thus contains a first optional installation layer which deploys the Kubernetes nodes (control plane(s) and workers) above an existing infrastructure (Iaas).

Then the second installation layer uses Helm charts to deploy and configure all the OC components.

This documentation will be updated with the needed command and/or requirements to properly execute the installation.

# Deploy cluster
## For dev in Docker
Install brew

    /bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"

Install Talos

    brew install siderolabs/tap/talosctl
    talosctl cluster create
# Install helm
    curl -fsSL -o get_helm.sh https://raw.githubusercontent.com/helm/helm/main/scripts/get-helm-3
    chmod 700 get_helm.sh
    ./get_helm.sh

# Create OpenCloud Chart
    helm create occhart
